// Code generated by protoc-gen-grpc-gateway. DO NOT EDIT.
// source: boter/v1/api.proto

/*
Package boterpb is a reverse proxy.

It translates gRPC into RESTful JSON APIs.
*/
package boterpb

import (
	"context"
	"io"
	"net/http"

	"github.com/grpc-ecosystem/grpc-gateway/v2/runtime"
	"github.com/grpc-ecosystem/grpc-gateway/v2/utilities"
	"google.golang.org/grpc"
	"google.golang.org/grpc/codes"
	"google.golang.org/grpc/grpclog"
	"google.golang.org/grpc/metadata"
	"google.golang.org/grpc/status"
	"google.golang.org/protobuf/proto"
)

// Suppress "imported and not used" errors
var _ codes.Code
var _ io.Reader
var _ status.Status
var _ = runtime.String
var _ = utilities.NewDoubleArray
var _ = metadata.Join

func request_BoterService_SampleMethod_0(ctx context.Context, marshaler runtime.Marshaler, client BoterServiceClient, req *http.Request, pathParams map[string]string) (proto.Message, runtime.ServerMetadata, error) {
	var protoReq SamplemessageRequest
	var metadata runtime.ServerMetadata

	var (
		val string
		ok  bool
		err error
		_   = err
	)

	val, ok = pathParams["sample_param"]
	if !ok {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "missing parameter %s", "sample_param")
	}

	protoReq.SampleParam, err = runtime.String(val)
	if err != nil {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "type mismatch, parameter: %s, error: %v", "sample_param", err)
	}

	msg, err := client.SampleMethod(ctx, &protoReq, grpc.Header(&metadata.HeaderMD), grpc.Trailer(&metadata.TrailerMD))
	return msg, metadata, err

}

func local_request_BoterService_SampleMethod_0(ctx context.Context, marshaler runtime.Marshaler, server BoterServiceServer, req *http.Request, pathParams map[string]string) (proto.Message, runtime.ServerMetadata, error) {
	var protoReq SamplemessageRequest
	var metadata runtime.ServerMetadata

	var (
		val string
		ok  bool
		err error
		_   = err
	)

	val, ok = pathParams["sample_param"]
	if !ok {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "missing parameter %s", "sample_param")
	}

	protoReq.SampleParam, err = runtime.String(val)
	if err != nil {
		return nil, metadata, status.Errorf(codes.InvalidArgument, "type mismatch, parameter: %s, error: %v", "sample_param", err)
	}

	msg, err := server.SampleMethod(ctx, &protoReq)
	return msg, metadata, err

}

// RegisterBoterServiceHandlerServer registers the http handlers for service BoterService to "mux".
// UnaryRPC     :call BoterServiceServer directly.
// StreamingRPC :currently unsupported pending https://github.com/grpc/grpc-go/issues/906.
// Note that using this registration option will cause many gRPC library features to stop working. Consider using RegisterBoterServiceHandlerFromEndpoint instead.
func RegisterBoterServiceHandlerServer(ctx context.Context, mux *runtime.ServeMux, server BoterServiceServer) error {

	mux.Handle("GET", pattern_BoterService_SampleMethod_0, func(w http.ResponseWriter, req *http.Request, pathParams map[string]string) {
		ctx, cancel := context.WithCancel(req.Context())
		defer cancel()
		var stream runtime.ServerTransportStream
		ctx = grpc.NewContextWithServerTransportStream(ctx, &stream)
		inboundMarshaler, outboundMarshaler := runtime.MarshalerForRequest(mux, req)
		var err error
		var annotatedContext context.Context
		annotatedContext, err = runtime.AnnotateIncomingContext(ctx, mux, req, "/proto.service.boter.v1.BoterService/SampleMethod", runtime.WithHTTPPathPattern("/v1/sample/{sample_param}"))
		if err != nil {
			runtime.HTTPError(ctx, mux, outboundMarshaler, w, req, err)
			return
		}
		resp, md, err := local_request_BoterService_SampleMethod_0(annotatedContext, inboundMarshaler, server, req, pathParams)
		md.HeaderMD, md.TrailerMD = metadata.Join(md.HeaderMD, stream.Header()), metadata.Join(md.TrailerMD, stream.Trailer())
		annotatedContext = runtime.NewServerMetadataContext(annotatedContext, md)
		if err != nil {
			runtime.HTTPError(annotatedContext, mux, outboundMarshaler, w, req, err)
			return
		}

		forward_BoterService_SampleMethod_0(annotatedContext, mux, outboundMarshaler, w, req, resp, mux.GetForwardResponseOptions()...)

	})

	return nil
}

// RegisterBoterServiceHandlerFromEndpoint is same as RegisterBoterServiceHandler but
// automatically dials to "endpoint" and closes the connection when "ctx" gets done.
func RegisterBoterServiceHandlerFromEndpoint(ctx context.Context, mux *runtime.ServeMux, endpoint string, opts []grpc.DialOption) (err error) {
	conn, err := grpc.DialContext(ctx, endpoint, opts...)
	if err != nil {
		return err
	}
	defer func() {
		if err != nil {
			if cerr := conn.Close(); cerr != nil {
				grpclog.Infof("Failed to close conn to %s: %v", endpoint, cerr)
			}
			return
		}
		go func() {
			<-ctx.Done()
			if cerr := conn.Close(); cerr != nil {
				grpclog.Infof("Failed to close conn to %s: %v", endpoint, cerr)
			}
		}()
	}()

	return RegisterBoterServiceHandler(ctx, mux, conn)
}

// RegisterBoterServiceHandler registers the http handlers for service BoterService to "mux".
// The handlers forward requests to the grpc endpoint over "conn".
func RegisterBoterServiceHandler(ctx context.Context, mux *runtime.ServeMux, conn *grpc.ClientConn) error {
	return RegisterBoterServiceHandlerClient(ctx, mux, NewBoterServiceClient(conn))
}

// RegisterBoterServiceHandlerClient registers the http handlers for service BoterService
// to "mux". The handlers forward requests to the grpc endpoint over the given implementation of "BoterServiceClient".
// Note: the gRPC framework executes interceptors within the gRPC handler. If the passed in "BoterServiceClient"
// doesn't go through the normal gRPC flow (creating a gRPC client etc.) then it will be up to the passed in
// "BoterServiceClient" to call the correct interceptors.
func RegisterBoterServiceHandlerClient(ctx context.Context, mux *runtime.ServeMux, client BoterServiceClient) error {

	mux.Handle("GET", pattern_BoterService_SampleMethod_0, func(w http.ResponseWriter, req *http.Request, pathParams map[string]string) {
		ctx, cancel := context.WithCancel(req.Context())
		defer cancel()
		inboundMarshaler, outboundMarshaler := runtime.MarshalerForRequest(mux, req)
		var err error
		var annotatedContext context.Context
		annotatedContext, err = runtime.AnnotateContext(ctx, mux, req, "/proto.service.boter.v1.BoterService/SampleMethod", runtime.WithHTTPPathPattern("/v1/sample/{sample_param}"))
		if err != nil {
			runtime.HTTPError(ctx, mux, outboundMarshaler, w, req, err)
			return
		}
		resp, md, err := request_BoterService_SampleMethod_0(annotatedContext, inboundMarshaler, client, req, pathParams)
		annotatedContext = runtime.NewServerMetadataContext(annotatedContext, md)
		if err != nil {
			runtime.HTTPError(annotatedContext, mux, outboundMarshaler, w, req, err)
			return
		}

		forward_BoterService_SampleMethod_0(annotatedContext, mux, outboundMarshaler, w, req, resp, mux.GetForwardResponseOptions()...)

	})

	return nil
}

var (
	pattern_BoterService_SampleMethod_0 = runtime.MustPattern(runtime.NewPattern(1, []int{2, 0, 2, 1, 1, 0, 4, 1, 5, 2}, []string{"v1", "sample", "sample_param"}, ""))
)

var (
	forward_BoterService_SampleMethod_0 = runtime.ForwardResponseMessage
)
